
var imgRows, mainPanel, genPanel, resultPanel, deletePanel, genProgress, 

mapShader, mapParams = new Float32Array(3*4), colorIdRt, distanceRt, mapRt,
distanceShader, basePlaneShader, addPlaneShader, errorShader, cameraShader, cubeMapShader, addPlaneCubeShader,
previewShader, previewParams = new Float32Array(2*4), cameraParams = new Float32Array(4*4), 
currentError = 0, errorRtA, errorRtB, errorBuf = new Uint8Array(1024*512*4), errorMultiple = 1, errorFrameCount = 0, errorFrameTime = 0, lastErrorFps = 0,

generating = false, computeStitch = false, stitchRoll = false, stitchDepth = false, draggingCamera = false, cameraYaw = 0, cameraPitch = 0,
maxImageHeight = 0, maxImageRows = 0, globalImageScale = 1, blendRange = 0.01, updatePreview = false, exportEquirect = false, exportCubemap = false, exportRes = 0,
deletingImage = null, loadImageRow = null, rows = [], lastSaveURL = null,
fbuf = new Float32Array(16), resolutions = [], littleEndian = true, cubeFaceId = 0, cubemapFaces,
bbuf = new Uint8Array(16), ibuf = new Int32Array(bbuf.buffer), ubuf = new Uint32Array(bbuf.buffer), u16buf = new Uint16Array(bbuf.buffer),

CUBEMAP_FACE_ANGLES = [Math.PI*1.5,0, Math.PI*0.5,0, 0,Math.PI*-0.5, 0,Math.PI*0.5, Math.PI,0, 0,0],
CUBE_FACE_NAMES = ["Left(-X)","Right(+X)","Down(-Y)","Up(+Y)","Back(-Z)","Forward(+Z)"];


//DOM loaded, program entry point
document.addEventListener("DOMContentLoaded",function() {
	//setup webgl
	if (!InitializeQuickWebGL(document.getElementById("display"))) {
		FatalCrash("Fatal Error: Your system does not support WebGL 2.");
		return false;
	}

	//initial opengl settings
	gl.blendFunc(gl.ONE,gl.ONE);
	gl.enable(gl.CULL_FACE);
	gl.cullFace(gl.BACK);
	gl.disable(gl.DEPTH_TEST);
	gl.depthMask(false);
	gl.clearDepth(1.0);
	gl.clearColor(0,0,0,1);
	gl.depthFunc(gl.LEQUAL);
	gl.disable(gl.STENCIL_TEST);
	gl.disable(gl.BLEND);
	gl.enable(gl.SCISSOR_TEST);
	gl.colorMask(true,true,true,true);
	
	//init opengl objects
	mapShader = new Shader(document.getElementById("RenderMap.glsl").textContent);
	previewShader = new Shader(document.getElementById("RenderPreview.glsl").textContent);
	distanceShader = new Shader(document.getElementById("Distance.glsl").textContent);
	basePlaneShader = new Shader(document.getElementById("BaseImage.glsl").textContent);
	addPlaneShader = new Shader(document.getElementById("AddPlane.glsl").textContent);
	errorShader = new Shader(document.getElementById("Error.glsl").textContent);
	cubeMapShader = new Shader(document.getElementById("CubeMap.glsl").textContent);
	cameraShader = new Shader(document.getElementById("CameraMap.glsl").textContent);
	addPlaneCubeShader = new Shader(document.getElementById("AddPlaneCube.glsl").textContent);
	
	//generate resolutions up to max texture size
	var maxTexSz = gl.getParameter(gl.MAX_TEXTURE_SIZE),
		cres = 128, rsel = [];
	while (cres < maxTexSz) {
		cres *= 2;
		resolutions.push(cres);
		rsel.push(cres+"x"+(cres/2));
	}
	
	//init ui
	mainPanel = document.getElementById("main");
	deletePanel = document.getElementById("dconfirm");
	genPanel = document.getElementById("generating");
	genProgress = document.getElementById("gen_prog");
	imgRows = document.getElementById("img_rows");
	AddImageRow();
	resultPanel = document.getElementById("result");
	SetSelectOptions("type_sel",["Full Sphere","Top Hemisphere","Bottom Hemisphere"],0);
	SetSelectOptions("gen_res",rsel,Math.floor(rsel.length/2));
	
	//clear current images
	BEC("clear",function() {
		deletingImage = null;
		TEV(deletePanel);
		TEV(mainPanel);
	});
	
	//generate
	BEC("gen",function() {
		//check if at least 2 rows
		if (rows.length < 3) return;
		
		//init images
		maxImageRows = 0;
		maxImageHeight = 0;
		var ptype = document.getElementById("type_sel").selectedIndex,
			rlen = rows.length-1;
		for (var ry = 0; ry < rlen; ry++) {
			var ro = rows[ry].images, pitch;
			if (ptype === 0) pitch = (0.5-(ry+0.5)/rlen)*Math.PI;//full sphere
			else if (ptype === 1) pitch = (1-(ry+0.5)/rlen)*Math.PI*0.5;//top hemisphere
			else pitch = ((ry+0.5)/rlen-1)*Math.PI*0.5;//bottom hemisphere
			
			maxImageRows = Math.max(maxImageRows,ro.length);
			for (var rx = 0; rx < ro.length; rx++) {
				var it = ro[rx];
				it.yaw = it.currYaw = it.baseYaw = rx*Math.PI*2/ro.length;//compute starting yaw/pitch of images
				it.pitch = it.currPitch = it.basePitch = pitch;

				it.texture = gl.createTexture();//load image into texture
				gl.bindTexture(gl.TEXTURE_2D,it.texture);
				SetTextureOptions(true,false,false,false);
				gl.texImage2D(gl.TEXTURE_2D,0,gl.RGBA,gl.RGBA,gl.UNSIGNED_BYTE,it.img);
				
				maxImageHeight = Math.max(maxImageHeight,it.img.naturalHeight);
			}
		}
		cameraYaw = cameraPitch = 0;
		
		//allocate framebuffers
		colorIdRt = new RenderTexture(1024,512,gl.RGBA,gl.RGBA,gl.UNSIGNED_BYTE,true);
		distanceRt = new RenderTexture(1024,512,gl.RGBA,gl.RGBA,gl.UNSIGNED_BYTE);
		SetTextureOptions(false,false,true,false);
		errorRtA = new RenderTexture(1024,512,gl.RGBA,gl.RGBA,gl.UNSIGNED_BYTE);
		errorRtB = new RenderTexture(1024,512,gl.RGBA,gl.RGBA,gl.UNSIGNED_BYTE);
		
		//switch to generating ui
		display.width = quickGLCanvas.width = Math.floor(window.innerWidth*0.95);
		display.height = quickGLCanvas.height = Math.floor(window.innerHeight*0.7);
		generating = true;
		updatePreview = true;
		TEV(mainPanel);
		TEV(genPanel);
		RenderPreview();
	});
	
	//begin stitching
	BEC("gen_compute",function(e) {
		computeStitch = !computeStitch;//toggle stitching
		e.target.textContent = computeStitch?"Stop Stitching":"Begin Stitching";
		if (computeStitch) {
			stitchRoll = document.getElementById("stitch_roll").checked;
			stitchDepth = document.getElementById("stitch_depth").checked;
			currentError = -1;
			errorMultiple = 1;
			errorFrameCount = 0;
			errorFrameTime = Date.now();
		} else {
			for (var i = 0; i < rows.length; i++) {//apply new yaw/pitch
				var row = rows[i].images;
				for (var c = 0; c < row.length; c++) {
					var tile = row[c];
					tile.yaw = tile.currYaw;
					tile.pitch = tile.currPitch;
					tile.depth = tile.currDepth;
					tile.roll = tile.currRoll;
				}
			}
			updatePreview = true;
		}
	});
	
	//change global scale
	document.getElementById("gen_scale").addEventListener("input",function(e) {
		globalImageScale = parseFloat(e.target.value);
		updatePreview = true;
	});
	//change blend range
	document.getElementById("blend_range").addEventListener("input",function(e) {
		blendRange = parseFloat(e.target.value);
		updatePreview = true;
	});
	
	//close generate ui
	BEC("gen_cancel",function() {
		generating = false;
	});
	
	//confirm delete
	BEC("delete",function() {
		if (deletingImage) {//delete one image
			var rowId = deletingImage.imageRowID,
				imgId = deletingImage.imageID,
				row = rows[rowId],
				tmp = row.images[imgId];
				debugger;
			for (var i = row.images.length-1; i > imgId; i--) {//shift later image elements
				row.element.insertBefore(row.images[i].img,row.images[i-1].img);
			}
			tmp.img.remove();
			row.images.splice(imgId,1);//remove image
	
			if (row.images.length === 0 && rows.length > 1) {
				//decrement above row ids
				for (var i = rowId+1; i < rows.length; i++) {
					var re = rows[i].element, rc = re.childNodes;
					for (var c = 0; c < rc.length; c++) {
						var rid = rc[c].imageRowID;
						if (rid !== undefined) rc[c].imageRowID = rid-1;
					}
				}
				row.element.remove();//delete whole row if no images
				rows.splice(rowId,1);
			} else {
				tmp = row.element.childNodes;//remove delete/swap button
				tmp[tmp.length-1].remove();
				if (row.images.length > 0) tmp[tmp.length-1].remove();
			}
			URL.revokeObjectURL(tmp.url);
		} else {
			//delete all images
			for (var i = 0; i < rows.length; i++) {
				var row = rows[i];
				for (var c = 0; c < row.images.length; c++) URL.revokeObjectURL(row.images[c].url);
			}
			rows = [];
			imgRows.innerHTML = "";
			AddImageRow();
		}
		TEV(deletePanel);
		TEV(mainPanel);
	});
	//cancel deleting
	BEC("dcancel",function() {
		TEV(deletePanel);
		TEV(mainPanel);
	});
	
	
	//save/load image order
	BEC("save_order",function() {
		var order = [];
		for (var i = 0; i < rows.length-1; i++) {
			var ra = [], row = rows[i].images;
			order.push(ra);
			for (var c = 0; c < row.length; c++) ra.push(row[c].fileId);
		}
	
		if (lastSaveURL) URL.revokeObjectURL(lastSaveURL);
		lastSaveURL = URL.createObjectURL(new Blob([JSON.stringify(order)]));
		SaveFilePrompt(lastSaveURL,"CubemapImageOrder.json");
	});
	BEC("load_order",function() {
		LoadFilePrompt(OnLoadOrder,"text/*",false);
	});
	
	
	//export equirectangular/cubemap
	BEC("gen_equirect",function() {
		StartExport(false);
	});
	BEC("gen_cubemap",function() {
		StartExport(true);
	});
	BEC("result_close",function() {
		if (!(exportEquirect || exportCubemap)) {
			//free cubemap faces
			if (cubemapFaces) {
				for (var i = 0; i < 6; i++) URL.revokeObjectURL(cubemapFaces[i].src);
				cubemapFaces = null;
			}
		
			TEV(resultPanel);
			TEV(genPanel);
			updatePreview = true;
			RenderPreview();
		}
	});

	
	//camera mouse look input
	quickGLCanvas.addEventListener("mousedown",function(e) {
		draggingCamera = true;
	});
	quickGLCanvas.addEventListener("mouseup",function(e) {
		draggingCamera = false;
	});
	quickGLCanvas.addEventListener("mousemove",function(e) {
		if (draggingCamera) {
			cameraYaw -= 4*e.movementX/window.innerWidth;
			cameraPitch += 4*e.movementY/window.innerWidth;
		}
	});
	
	//camera touch look input
	quickGLCanvas.addEventListener("touchstart",function(e) {
		draggingCamera = e.touches[0];
		e.preventDefault();
		e.stopPropagation();
	});
	quickGLCanvas.addEventListener("touchmove",function(e) {
		var nt = e.touches[0];
		cameraYaw -= 4*((nt.clientX-draggingCamera.clientX)/window.innerWidth);
		cameraPitch += 4*((nt.clientY-draggingCamera.clientY)/window.innerWidth);
		draggingCamera = nt;
		e.preventDefault();
		e.stopPropagation();
	});
	quickGLCanvas.addEventListener("touchend",function(e) {
		if (e.touches.length === 0) draggingCamera = null;
		else draggingCamera = e.touches[0];
		e.preventDefault();
		e.stopPropagation();
	});
	quickGLCanvas.addEventListener("touchcancel",function(e) {
		if (e.touches.length === 0) draggingCamera = null;
		else draggingCamera = e.touches[0];
		e.preventDefault();
		e.stopPropagation();
	});
});




//display fullscreen crash message
function FatalCrash(msg) {
	document.body.innerHTML = "<span class='fatalcrash'>"+msg+"</span>";
}

//shortcut for getting element by id and adding click event listener
function BEC(id,cb) {
	document.getElementById(id).addEventListener("click",cb);
}

//shortcut for toggling visibility of element, returns true if now visible
function TEV(ele) {
	var vis = ele.style.display=="none";
	ele.style.display = vis?"block":"none";
	return vis;
}

//initialize select element options
function SetSelectOptions(id,opt,defaultInd) {
	var ele = document.getElementById(id);
	for (var i = 0; i < opt.length; i++) {
		var oe = document.createElement("option");
		oe.textContent = opt[i];
		ele.appendChild(oe);
	}
	ele.selectedIndex = defaultInd?defaultInd:0;
}


//load file prompt hooked to callback, must be called from event like onclick
function LoadFilePrompt(callback,acceptType,multiple) {
	var fi = document.createElement("input");
	fi.type = "file";
	if (acceptType) fi.accept = acceptType;
	if (multiple) fi.multiple = true;
	fi.addEventListener("change",callback);
	fi.click();
}
//save file containing data in dataUrl, must be called from event
function SaveFilePrompt(dataUrl,fname) {
	var a = document.createElement("a");
	a.href = dataUrl;
	a.download = fname;
	a.click();
}

/**@constructor*/
function ImageRow(ele) {
	this.element = ele;
	this.images = [];
}

/**@constructor*/
function ImageTile(iurl,fid) {
	this.url = iurl;
	this.img = new Image();
	this.img.className = "rimg";
	this.img.src = iurl;
	
	this.baseYaw = 0;
	this.yaw = 0;
	this.currYaw = 0;
	this.lastYaw = 0;
	
	this.basePitch = 0;
	this.pitch = 0;
	this.currPitch = 0;
	this.lastPitch = 0;
	
	this.depth = 1;
	this.currDepth = 1;
	this.lastDepth = 1;
	
	this.roll = 0;
	this.currRoll = 0;
	this.lastRoll = 0;

	this.texture = null;
	this.fileId = fid;
}


/*Class: EulerRotation
Optimized euler angle rotation class, caches cos/sin values.

Constructor: EulerRotation
New EulerRotation.

Parameters:
*float* roll - Roll rotation in radians, if undefined defaults to 0.
*float* pitch - Pitch rotation in radians.
*float* yaw - Yaw rotation in radians.*/
/**@constructor*/
function EulerRotation(roll,pitch,yaw) {
	/*Property: roll
	*float* Roll rotation in radians.*/
	this.roll = roll?roll:0;
	/*Property: pitch
	*float* Pitch rotation in radians.*/
	this.pitch = pitch?pitch:0;
	/*Property: yaw
	*float* Yaw rotation in radians.*/
	this.yaw = yaw?yaw:0;
	
	this.rollCos = Math.cos(this.roll); this.rollSin = Math.sin(this.roll);
	this.pitchCos = Math.cos(this.pitch); this.pitchSin = Math.sin(this.pitch);
	this.yawCos = Math.cos(this.yaw); this.yawSin = Math.sin(this.yaw);
}
/*Property: tmpEuler
<EulerRotation> Temporary euler rotation buffer.*/
var tmpEuler = new EulerRotation();

/*Function: Set
Set euler rotation, you must call this to update cached cos/sin values.

Parameters:
*float* roll - Roll rotation in radians.
*float* pitch - Pitch rotation in radians.
*float* yaw - Yaw rotation in radians.*/
EulerRotation.prototype.Set = function(roll,pitch,yaw) {
	this.roll = roll;
	this.pitch = pitch;
	this.yaw = yaw;
	this.rollCos = Math.cos(roll); this.rollSin = Math.sin(roll);
	this.pitchCos = Math.cos(pitch); this.pitchSin = Math.sin(pitch);
	this.yawCos = Math.cos(yaw); this.yawSin = Math.sin(yaw);
}
/*Function: Apply
Applies euler rotation to vector 'x', 'y', 'z', outputs result in fbuf[0], fbuf[1], fbuf[2].

Parameters:
*float* x - X coordinate.
*float* y - Y coordinate.
*float* z - Z coordinate.*/
EulerRotation.prototype.Apply = function(x,y,z) {
	if (this.roll) {
		fbuf[0] = x;
		x = x*this.rollCos+y*this.rollSin;
		y = y*this.rollCos-fbuf[0]*this.rollSin;
	}
	if (this.pitch) {
		fbuf[1] = y*this.pitchCos+z*this.pitchSin;
		z = z*this.pitchCos-y*this.pitchSin;
	} else fbuf[1] = y;
	if (this.yaw) {
		fbuf[0] = x*this.yawCos+z*this.yawSin;
		fbuf[2] = z*this.yawCos-x*this.yawSin;
	} else {
		fbuf[0] = x;
		fbuf[2] = z;
	}
}
/*Function: ApplyInverse
Applies inverted euler rotation to vector 'x', 'y', 'z', outputs result in fbuf[0], fbuf[1], fbuf[2].

Parameters:
*float* x - X coordinate.
*float* y - Y coordinate.
*float* z - Z coordinate.*/
EulerRotation.prototype.ApplyInverse = function(x,y,z) {
	if (this.yaw) {
		fbuf[0] = x;
		x = x*this.yawCos-z*this.yawSin;
		z = z*this.yawCos+fbuf[0]*this.yawSin;
	}
	if (this.pitch) {
		fbuf[0] = y;
		y = y*this.pitchCos-z*this.pitchSin;
		fbuf[2] = z*this.pitchCos+fbuf[0]*this.pitchSin;
	} else fbuf[2] = z;
	if (this.roll) {
		fbuf[0] = x*this.rollCos-y*this.rollSin;
		fbuf[1] = y*this.rollCos+x*this.rollSin;
	} else {
		fbuf[0] = x;
		fbuf[1] = y;
	}
}

/*Function: AngleDelta
Calculate and return delta value between angles 'a1' and 'a2'.

Parameters:
*float* a1 - Angle 1 in radians.
*float* a2 - Angle 2 in radians.

Returns:
*float* Delta value between angles.*/
function AngleDelta(a1,a2) {
	var d = a2-a1, a = Math.abs(d);
	if (a > Math.PI) return (Math.PI*2-a)*-Math.sign(d);
	return d;
}

//create new image row
function AddImageRow() {
	var nrow = document.createElement("div");
	nrow.className = "imgrow";
	imgRows.appendChild(nrow);
	
	var pbtn = document.createElement("span");
	pbtn.className = "pbtn";
	pbtn.textContent = "+";
	pbtn.imageRowID = rows.length;
	pbtn.addEventListener("click",OnAddImages);
	nrow.appendChild(pbtn);
	
	rows.push(new ImageRow(nrow));
}

//create swap button element
function AddSwapButton(rowId,imgId) {
	var sbtn = document.createElement("span");
	sbtn.className = "swap";
	sbtn.textContent = ">";
	sbtn.addEventListener("click",OnSwapImage);
	sbtn.imageRowID = rowId;
	sbtn.imageID = imgId;
	return sbtn;
}

//create image delete button element
function AddDeleteButton(rowId,imgId) {
	var dbtn = document.createElement("span");
	dbtn.className = "dimg";
	dbtn.textContent = "X";
	dbtn.imageRowID = rowId;
	dbtn.imageID = imgId;
	dbtn.addEventListener("click",OnDeleteImage);
	return dbtn;
}

//load image files
function OnAddImages(e) {
	loadImageRow = e.target.imageRowID;
	LoadFilePrompt(OnLoadImages,"image/*",true);
}
function OnLoadImages(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var ro = rows[loadImageRow];
		if (loadImageRow === rows.length-1 && ro.images.length === 0) AddImageRow();
		
		for (var i = 0; i < fs.length; i++) {
			var iid = ro.images.length;
			if (iid) ro.element.appendChild(AddSwapButton(loadImageRow,iid));
			
			var nimg = new ImageTile(URL.createObjectURL(fs[i]),fs[i].name+fs[i].size);//img object
			ro.element.appendChild(nimg.img);
			ro.images.push(nimg);
			
			ro.element.appendChild(AddDeleteButton(loadImageRow,iid));
		}
	}
}

//swap images button
function OnSwapImage(e) {
	var rowId = e.target.imageRowID,
		imgId = e.target.imageID,
		row = rows[rowId],
		tmp = row.images[imgId];
	row.images[imgId] = row.images[imgId-1];//swap image objects
	row.images[imgId-1] = tmp;
	
	tmp = row.element.childNodes;
	imgId = 1+imgId*3;
	row.element.insertBefore(tmp[imgId],tmp[imgId-2]);//swap image elements
	row.element.insertBefore(tmp[imgId-3],tmp[imgId+1]);
}

//on delete image button click
function OnDeleteImage(e) {
	deletingImage = e.target;
	TEV(deletePanel);
	TEV(mainPanel);
}


//load saved image order
function OnLoadOrder(e) {
	var fs = e.target.files;
	if (fs && fs.length) {
		var fr = new FileReader();
		fr.onload = OnLoadOrderText;
		fr.readAsText(fs[0]);
	}
}
function OnLoadOrderText(e) {
	var order = JSON.parse(e.target.result);
	//validate order
	if (!order.length || !order[0].length) return;
	
	var images = {};
	for (var i = 0; i < rows.length; i++) {//grab all images to be ordered
		var row = rows[i].images;
		for (var c = 0; c < row.length; c++) images[row[c].fileId] = row[c];
	}
	
	//delete old rows
	rows = [];
	imgRows.innerHTML = "";
	AddImageRow();
	
	//place images back in order
	for (var i = 0; i < order.length; i++) {
		if (rows.length < i+1) AddImageRow();
		var orow = order[i], row = rows[i];
		for (var c = 0; c < orow.length; c++) {
			var tile = images[orow[c]];
			if (tile) {
				var iid = row.images.length;
				if (iid) row.element.appendChild(AddSwapButton(i,iid));
				row.element.appendChild(tile.img);
				row.images.push(tile);
				row.element.appendChild(AddDeleteButton(i,iid));
			}
		}
	}
	
	//delete unused images
	for (var k in images) URL.revokeObjectURL(images[k].url);
	
	//add new image row if needed
	if (rows[rows.length-1].images.length) AddImageRow();
}



//write little endian uint32 to byte array
function WriteU32(dst,ind,val) {
	ubuf[0] = val;
	if (littleEndian) {
		for (var i = 0; i < 4; i++) dst[ind++] = bbuf[i];
	} else {
		for (var i = 0; i < 4; i++) dst[ind++] = bbuf[3-i];
	}
	return ind;
}
//int32
function WriteI32(dst,ind,val) {
	ibuf[0] = val;
	if (littleEndian) {
		for (var i = 0; i < 4; i++) dst[ind++] = bbuf[i];
	} else {
		for (var i = 0; i < 4; i++) dst[ind++] = bbuf[3-i];
	}
	return ind;
}
//uint16
function WriteU16(dst,ind,val) {
	u16buf[0] = val;
	if (littleEndian) {
		for (var i = 0; i < 2; i++) dst[ind++] = bbuf[i];
	} else {
		for (var i = 0; i < 2; i++) dst[ind++] = bbuf[3-i];
	}
	return ind;
}
//manual bitmap encoding
function SaveBMP(wt,ht) {
	//test endianness
	ubuf[0] = 1;
	littleEndian = bbuf[0]===1;
	
	//create bmp byte buffer and init header
	var dat = new Uint8Array(54+wt*ht*4);
	dat[0] = ("B").charCodeAt(0);
	dat[1] = ("M").charCodeAt(0);
	WriteU32(dat,2,54+wt*ht*3);//total size
	WriteU32(dat,10,54);//header size
	WriteU32(dat,14,40);//header size
	WriteI32(dat,18,wt);//width
	WriteI32(dat,22,ht);//height
	WriteU16(dat,26,1);//color planes
	WriteU16(dat,28,24);//bits per pixel
	WriteU32(dat,30,0);//compression
	WriteU32(dat,34,0);
	WriteI32(dat,38,1000);//x pixels per metre
	WriteI32(dat,42,1000);//y pixels per metre
	WriteU32(dat,46,0);//color palette
	WriteU32(dat,50,0);//important colors
	
	//read pixels
	gl.readPixels(0,0,exportRes,ht,gl.RGBA,gl.UNSIGNED_BYTE,dat,54);
	
	//bmp pixel conversion, remove alpha and flip rgb to bgr
	var wi = 54, ri = 54;
	for (var y = 0; y < ht; y++) {
		for (var x = 0; x < wt; x++) {
			dat[wi++] = dat[ri+2];
			dat[wi++] = dat[ri+1];
			dat[wi++] = dat[ri];
			ri += 4;
		}
	}

	if (lastSaveURL) URL.revokeObjectURL(lastSaveURL);
	lastSaveURL = URL.createObjectURL(new Blob([dat.subarray(0,54+wt*ht*3).buffer],{"type":"application/octet-stream"}));
}



//show export ui and start export
function StartExport(cubemap) {
	document.getElementById("resultbox").innerHTML = "Exporting...";
	if (cubemap) {
		exportCubemap = true;
		cubeFaceId = 0;
	} else exportEquirect = true;
	exportRes = resolutions[document.getElementById("gen_res").selectedIndex];
	TEV(resultPanel);
	TEV(genPanel);
}


//compute plane matrix and put values into float array
function ComputePlaneMatrix(img,dst,ind) {
	var imgScale = globalImageScale*4/maxImageRows/maxImageHeight;
	tmpEuler.Set(img.roll,img.pitch,img.yaw);
	tmpEuler.Apply(0,0,img.depth);//forward
	dst[ind++] = fbuf[0]; dst[ind++] = fbuf[1]; dst[ind++] = fbuf[2]; ind++;
	tmpEuler.Apply(0.5/(img.img.naturalWidth*imgScale),0,0);//right
	dst[ind++] = fbuf[0]; dst[ind++] = fbuf[1]; dst[ind++] = fbuf[2]; ind++;
	tmpEuler.Apply(0,-0.5/(img.img.naturalHeight*imgScale),0);//up
	dst[ind++] = fbuf[0]; dst[ind++] = fbuf[1]; dst[ind] = fbuf[2];
}


//render planes with specific shader
function RenderPlanes(shader,params) {
	var planeId = 0,
		imgUni = shader["img"];
	for (var ry = 0; ry < rows.length; ry++) {
		var ro = rows[ry];
		for (var rx = 0; rx < ro.images.length; rx++) {
			var ri = ro.images[rx];
			ComputePlaneMatrix(ri,params,0);
			params[11] = planeId/255;

			gl.uniform4fv(shader["params"],params);
			BindTexture(imgUni,ri.texture);
			gl.drawArrays(gl.TRIANGLES,0,3);
			UnbindTexture(imgUni);
			
			planeId++;
		}
	}
}

//render color/id and distance map
function RenderMapAndDistance(blurPx,yawOffset,pitchOffset,yawSize,pitchSize) {
	//render image planes to equirectangular map
	colorIdRt.Bind();
	gl.enable(gl.DEPTH_TEST);
	gl.depthMask(true);
	gl.clear(gl.DEPTH_BUFFER_BIT|gl.COLOR_BUFFER_BIT);
	mapShader.Use();
	RenderPlanes(mapShader,mapParams);
	gl.disable(gl.DEPTH_TEST);
	gl.depthMask(false);

	//compute distance
	distanceRt.Bind();
	distanceShader.Use();
	gl.uniform4f(distanceShader["params"],blurPx*0.5/distanceRt.width,blurPx*0.5/distanceRt.height,1/distanceRt.width,1/distanceRt.height);
	BindTexture(distanceShader["img"],colorIdRt.texture);
	gl.drawArrays(gl.TRIANGLES,0,3);
	UnbindAllTextures();
}

//render final blended map
function RenderFinal(rt) {
	//base image
	rt.Bind();
	basePlaneShader.Use();
	BindTexture(basePlaneShader["img"],colorIdRt.texture);
	BindTexture(basePlaneShader["weight"],distanceRt.texture);
	gl.drawArrays(gl.TRIANGLES,0,3);
	UnbindAllTextures();
	
	//add blended planes
	gl.enable(gl.BLEND);
	addPlaneShader.Use();
	BindTexture(addPlaneShader["weight"],distanceRt.texture);
	RenderPlanes(addPlaneShader,mapParams);
	UnbindAllTextures();
	gl.disable(gl.BLEND);
}


//render error
function RenderError(rt) {
	rt.Bind();
	gl.clear(gl.COLOR_BUFFER_BIT);
	gl.enable(gl.BLEND);
	errorShader.Use();
	BindTexture(errorShader["map"],colorIdRt.texture);
	BindTexture(errorShader["weight"],distanceRt.texture);
	RenderPlanes(errorShader,mapParams);
	UnbindAllTextures();
	gl.disable(gl.BLEND);
}

//read error value from current framebuffer
function ReadError() {
	gl.readPixels(0,0,1024,512,gl.RGBA,gl.UNSIGNED_BYTE,errorBuf);
	//average error
	var px = 0, err = 0, nrm = 0;
	for (var y = 0; y < 512; y++) {
		for (var x = 0; x < 1024; x++) {
			err += errorBuf[px++];
			err += errorBuf[px++];
			err += errorBuf[px++];
			px++;
			//nrm += errorBuf[px++];
		}
	}
	return err;///Math.max(1,nrm);
}

//render preview and compute stitching
function RenderPreview() {
	if (exportEquirect) {
		requestAnimationFrame(ExportEquirect);
		return;
	}
	if (exportCubemap) {
		requestAnimationFrame(ExportCubemap);
		return;
	}


	if (computeStitch) {
		for (var rep = 0; rep < errorMultiple; rep++) {
			//randomize configuration
			var pitchRange = Math.PI/rows.length*0.45, depthRange = 0.3/maxImageRows;
			for (var i = 0; i < rows.length; i++) {
				var ro = rows[i].images,
					yawRange = Math.PI*2/ro.length*0.45;
				for (var c = 0; c < ro.length; c++) {
					var tile = ro[c], yrnd = 0, prnd = 0, drnd = 0, rrnd = 0;
					if (currentError !== -1) {
						yrnd = Math.random()*2-1; yrnd = Math.pow(Math.abs(yrnd),39)*yrnd;
						prnd = Math.random()*2-1; prnd = Math.pow(Math.abs(prnd),39)*prnd;
						if (stitchDepth) {
							drnd = Math.random()*2-1; drnd = Math.pow(Math.abs(drnd),29)*drnd;
						}
						if (stitchRoll) {
							rrnd = Math.random()*2-1; rrnd = Math.pow(Math.abs(rrnd),29)*rrnd;
						}	
					}
				
					tile.lastYaw = tile.yaw;
					tile.lastPitch = tile.pitch;
					tile.lastDepth = tile.depth;
					tile.lastRoll = tile.roll;
					
					tile.yaw = Math.max(tile.baseYaw-yawRange, Math.min(tile.baseYaw+yawRange, tile.currYaw+yrnd*yawRange));
					tile.pitch  = Math.max(tile.basePitch-pitchRange, Math.min(tile.basePitch+pitchRange, tile.currPitch+prnd*pitchRange));
					tile.depth = Math.max(1-depthRange,Math.min(1+depthRange, tile.currDepth+drnd*depthRange));
					tile.roll = Math.max(-0.1,Math.min(0.1, tile.currRoll+rrnd*0.1));
				}
			}
			
			//render error of new config
			RenderMapAndDistance(6,0,0,Math.PI,Math.PI*0.5);
			RenderError(errorRtA);
		
			//test error of last frames config, delaying readpixels by a frame gives the gpu operation time to complete vastly increasing performance
			if (currentError === -1) {
				currentError = 1e8;
			} else {
		
				errorRtB.Bind();
				var newError = ReadError();
				if (newError < currentError) {
					//use config if error is lower
					for (var i = 0; i < rows.length; i++) {
						var ro = rows[i].images;
						for (var c = 0; c < ro.length; c++) {
							var tile = ro[c];
							tile.currYaw = tile.lastYaw;
							tile.currPitch = tile.lastPitch;
							tile.currDepth = tile.lastDepth;
							tile.currRoll = tile.lastRoll;
						}
					}
					currentError = newError;
				}
			}
		
			var tmp = errorRtA;
			errorRtA = errorRtB;
			errorRtB = tmp;
		}
	
		//frame timing
		errorFrameCount++;
		var ctime = Date.now(), dtime = ctime-errorFrameTime;
		if (dtime >= 1000) {
			var fps = errorFrameCount*1000/dtime;
			if (fps >= lastErrorFps) errorMultiple++;
			else if (fps < lastErrorFps*0.75) errorMultiple = Math.max(1, errorMultiple-1);
			lastErrorFps = fps;
			errorFrameTime = ctime;
			errorFrameCount = 0;
		}
		
	}


	if (!document.hidden) {
		if (updatePreview) {
			RenderMapAndDistance(Math.floor(blendRange*distanceRt.height*0.25),0,0,Math.PI,Math.PI*0.5);
			RenderFinal(errorRtA);
			updatePreview = false;
		}
	
		//render preview
		display.Bind();
		
		var rp = previewParams;
		rp[0] = Math.cos(cameraYaw); rp[1] = Math.sin(cameraYaw);
		rp[2] = Math.cos(cameraPitch); rp[3] = Math.sin(cameraPitch);
		rp[4] = display.width/display.height*0.75; rp[5] = 0.75;
		
		previewShader.Use();
		gl.uniform4fv(previewShader["params"],rp);
		BindTexture(previewShader["map"],computeStitch?colorIdRt.texture:errorRtA.texture);
		gl.drawArrays(gl.TRIANGLES,0,3);
		UnbindAllTextures();
	}
	
	
	if (generating) requestAnimationFrame(RenderPreview);
	else {
		//clear textures
		for (var ry = 0; ry < rows.length; ry++) {
			var ro = rows[ry];
			for (var rx = 0; rx < ro.images.length; rx++) gl.deleteTexture(ro.images[rx].texture);
		}
		//delete framebuffers
		colorIdRt.Delete();
		distanceRt.Delete();
		errorRtA.Delete();
		errorRtB.Delete();

		TEV(genPanel);
		TEV(mainPanel);
	}
}



//export equirectangular map
function ExportEquirect() {
	var ht = exportRes/2;//render export to framebuffer
	colorIdRt.SetSize(exportRes,ht);
	distanceRt.SetSize(exportRes,ht);
	errorRtA.SetSize(exportRes,ht);
	RenderMapAndDistance(Math.floor(blendRange*distanceRt.height*0.25),0,0,Math.PI,Math.PI*0.5);
	RenderFinal(errorRtA);
	colorIdRt.SetSize(1024,512);
	distanceRt.SetSize(1024,512);
	
	//get framebuffer as data url and save
	quickGLCanvas.width = exportRes; quickGLCanvas.height = ht;
	gl.bindFramebuffer(gl.DRAW_FRAMEBUFFER,null);
	gl.bindFramebuffer(gl.READ_FRAMEBUFFER,errorRtA.framebuffer);
	gl.blitFramebuffer(0,0,exportRes,ht,exportRes,0,0,ht,gl.COLOR_BUFFER_BIT,gl.NEAREST);//use blit to also flip X
	quickGLCanvas.toBlob(OnGetEquirectBlob,"image/png");
}

function OnGetEquirectBlob(blob) {
	var rbox = document.getElementById("resultbox");
	if (blob) {
		if (lastSaveURL) URL.revokeObjectURL(lastSaveURL);
		lastSaveURL = URL.createObjectURL(blob);
	} else {
		SaveBMP(exportRes,exportRes/2);//to blob failed fallback to manual bmp encoding
	}
	var nimg = new Image();
	nimg.style.width = "90vw";
	nimg.src = lastSaveURL;
	rbox.innerHTML = "";
	rbox.appendChild(nimg);
	
	display.width = quickGLCanvas.width = Math.floor(window.innerWidth*0.95);
	display.height = quickGLCanvas.height = Math.floor(window.innerHeight*0.7);
	errorRtA.SetSize(1024,512);
	exportEquirect = false;
}



//export cubemap
function ExportCubemap() {
	if (cubeFaceId === 0) {//initialize
		quickGLCanvas.width = display.width = exportRes; quickGLCanvas.height = display.height = exportRes;
		var blendRes = Math.floor(exportRes*(1.25+0.25*blendRange));
		colorIdRt.SetSize(blendRes,blendRes);
		distanceRt.SetSize(blendRes,blendRes);
		if (blendRange) errorRtA.SetSize(blendRes,blendRes);
		cubemapFaces = new Array(6);
	}
	
	//render color/id image planes
	var yawRange = Math.PI*0.5*(1+blendRange*0.25),
		pitchRange = Math.PI*0.25*(1+blendRange*0.25),
		cyaw = CUBEMAP_FACE_ANGLES[cubeFaceId*2], cpitch  = CUBEMAP_FACE_ANGLES[cubeFaceId*2+1],
		cp = cameraParams;
	cp[3] = yawRange;
	cp[7] = pitchRange;
	cp[12] = Math.cos(cyaw); cp[13] = Math.sin(cyaw);
	cp[14] = Math.cos(cpitch); cp[15] = Math.sin(cpitch);
	
	colorIdRt.Bind();
	gl.enable(gl.DEPTH_TEST);
	gl.depthMask(true);
	gl.clear(gl.DEPTH_BUFFER_BIT|gl.COLOR_BUFFER_BIT);
	cameraShader.Use();
	RenderPlanes(cameraShader,cp);
	gl.disable(gl.DEPTH_TEST);
	gl.depthMask(false);
	
	//blending
	if (blendRange) {
		//compute distance
		var blurPx = Math.floor(Math.PI*0.25/pitchRange*distanceRt.height*blendRange*0.2);
		distanceRt.Bind();
		distanceShader.Use();
		gl.uniform4f(distanceShader["params"],blurPx*0.5/distanceRt.width,blurPx*0.5/distanceRt.height,5/distanceRt.width,5/distanceRt.height);
		BindTexture(distanceShader["img"],colorIdRt.texture);
		gl.drawArrays(gl.TRIANGLES,0,3);
		UnbindAllTextures();
		
		//base image
		errorRtA.Bind();
		basePlaneShader.Use();
		BindTexture(basePlaneShader["img"],colorIdRt.texture);
		BindTexture(basePlaneShader["weight"],distanceRt.texture);
		gl.drawArrays(gl.TRIANGLES,0,3);
		UnbindAllTextures();
	
		//add blended planes
		gl.enable(gl.BLEND);
		addPlaneCubeShader.Use();
		BindTexture(addPlaneCubeShader["weight"],distanceRt.texture);
		RenderPlanes(addPlaneCubeShader,cp);
		UnbindAllTextures();
		gl.disable(gl.BLEND);
	}
	
	//render cubemap face
	display.Bind();
	cubeMapShader.Use();
	var pp = previewParams;
	pp[0] = cp[12]; pp[1] = cp[13];
	pp[2] = cp[14]; pp[3] = cp[15];
	pp[4] = yawRange; pp[5] = pitchRange;
	pp[7] = cubeFaceId;
	gl.uniform4fv(cubeMapShader["params"],pp);
	BindTexture(cubeMapShader["img"],blendRange?errorRtA.texture:colorIdRt.texture);
	gl.drawArrays(gl.TRIANGLES,0,3);
	UnbindAllTextures();
	
	quickGLCanvas.toBlob(OnGetCubeMapBlob,"image/png");
}
function OnGetCubeMapBlob(blob) {
	var nurl;
	if (blob) {
		nurl = URL.createObjectURL(blob);
	} else {
		SaveBMP(exportRes,exportRes/2);//to blob failed fallback to manual bmp encoding
		nurl = lastSaveURL;
		lastSaveURL = null;
	}
	var nimg = new Image();//make cubemap face into image
	nimg.style.width = "50vh";
	nimg.src = nurl;
	cubemapFaces[cubeFaceId] = nimg;
		
	cubeFaceId++;
	if (cubeFaceId < 6) {
		requestAnimationFrame(ExportCubemap);
	} else {
		//done, display results
		var rbox = document.getElementById("resultbox");
		rbox.innerHTML = "";
		for (var i = 0; i < 6; i++) {
			rbox.appendChild(document.createTextNode(" "+CUBE_FACE_NAMES[i]));
			rbox.appendChild(cubemapFaces[i]);
		}
		
		display.width = quickGLCanvas.width = Math.floor(window.innerWidth*0.95);
		display.height = quickGLCanvas.height = Math.floor(window.innerHeight*0.7);
		colorIdRt.SetSize(1024,512);
		distanceRt.SetSize(1024,512);
		errorRtA.SetSize(1024,512);
		exportCubemap = false;
	}
}
